//  A to D test code
// NOTE -- You MUST MOUNT the Aref jumper  

#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdio.h>
#include "uart.h"
#include "uart.c"

// UART file descriptor
// putchar and getchar are in uart.c
FILE uart_str = FDEV_SETUP_STREAM(uart_putchar, uart_getchar, _FDEV_SETUP_RW);
              
//I like these definitions
#define begin {
#define end   }  

char Ain ; 		//raw A to D number
char AinL;
int reading;

unsigned char time1;

ISR(TIMER0_COMPA_vect)
{
	if(time1>0) --time1;
	PORTB = PORTB ^ 1;
}

int main(void)
begin 

	//set up timer 0
	//init
	//set up timer 0 for 1 mSec timebase 
  	TIMSK0= (1<<OCIE0A);	//turn on timer 0 cmp match ISR 
  	OCR0A = 249;  		//set the compare re to 250 time ticks
  	//set prescalar to divide by 64 
  	TCCR0B= 3; //0b00001011;	
  	// turn on clear-on-match
  	TCCR0A= (1<<WGM01);

	time1 = 250;

   //init the A to D converter 
   //channel zero/ left adj /EXTERNAL Aref
   //!!!CONNECT Aref jumper!!!!
   //ADMUX = (1<<ADLAR) ;  
   ADMUX = 0;
    
   //enable ADC and set prescaler to 1/128*16MHz=125,000
   //and clear interupt enable
   //and start a conversion
   ADCSRA = (1<<ADEN) | (1<<ADSC) + 7 ; 
    
   // init the UART -- uart_init() is in uart.c
  uart_init();
  stdout = stdin = stderr = &uart_str;
  fprintf(stdout,"Starting ADC demo...\n\r"); 
      
  sei();

  DDRB = 0xff;
  PORTB = 1;

   // measure and display loop
   while (1)
   begin   
		//get the sample  
		AinL = ADCL;
		Ain = ADCH;
		reading = 0;
		reading = Ain << 8;
		reading += AinL;

 		//start another conversion
 		ADCSRA |= (1<<ADSC) ; 
 		//results to hyperterm
		//fprintf(stdout, " ");
  		if(time1 == 0) {
			time1 = 250;
			//fprintf(stdout, "AinL %d\n\r",AinL);
			//fprintf(stdout, "Ain %d\n\r", Ain);
			fprintf(stdout, "%d\n\r", reading);
			PORTB = PORTB ^ 1;
		}
  end
end
     
